﻿DeclareModule Spectr

Structure SpectrData
  Arr.f[256]
EndStructure


Declare Init()
Declare SendData(*Data.SpectrData)
EndDeclareModule

Module Spectr

EnableExplicit

#Message = #PB_Event_FirstCustomValue + 2

Structure SpectrInfo Extends SpectrData
  Mutex.i
  ThreadID.i
  Flag.l
EndStructure

Global gSpectrInfo.SpectrInfo

Procedure Draw(Array Infa.f(1))
  Protected x, i
  If StartDrawing(CanvasOutput(0))
    
    DrawingMode(#PB_2DDrawing_Gradient)

    LinearGradient(0, 0, 0, 64)
    
    BackColor($DFDFDF)
    FrontColor($888888)
    
    Box(0,0, 180, 64, 0)
      
    BackColor($0000FF)
    FrontColor($00FF00)
    
    x=0
    For i=0 To 17
      Box(i*8+x, 64-Infa(i), 8, Infa(i), 0)
      x+2
    Next i
    
    StopDrawing()
  EndIf
EndProcedure

Macro ChannelData(Start, Ends, Num)
  For i = Start/2 To Ends/2
    TempF = Buff\Arr[i]
    If Z(Num) < TempF/(100/64)
      Z(Num) = TempF/(100/64)
    EndIf
  Next i
EndMacro

Procedure GetSpectr()
  Protected Buff.SpectrData
  Protected i, TempF.f
  Protected Dim Z.f(18)
  
  LockMutex(gSpectrInfo\Mutex)
  CopyMemory(@gSpectrInfo\Arr[0], @Buff, SizeOf(SpectrData))
  UnlockMutex(gSpectrInfo\Mutex)
  
  ChannelData(1, 1, 0) ;13 Hz
  ChannelData(2, 2, 1) ;16 Hz 
  ChannelData(3, 3, 2) ;24 Hz 
  ChannelData(4, 4, 3) ;35 Hz
  ChannelData(5, 7, 4) ;53 Hz
  ChannelData(8, 9, 5) ;79 Hz 
  ChannelData(9, 11, 6);118 Hz 
  ChannelData(12, 15, 7) ;178 Hz 
  ChannelData(16, 23, 8) ;267 Hz
  ChannelData(24, 31, 9) ;400 Hz
  ChannelData(32, 47, 10);600 Hz 
  ChannelData(48, 63, 11);900 Hz
  ChannelData(64, 95, 12);1350 Hz
  ChannelData(96, 127, 13) ;2024 Hz
  ChannelData(128, 191, 14);3036 Hz
  ChannelData(192, 255, 15);4554 Hz
  ChannelData(256, 383, 16);6830 Hz
  ChannelData(384, 512, 17);10250 Hz
  
  Draw(z())
EndProcedure

Procedure Thread(*x)
  
  OpenWindow(0, 0, 0, 200, 100, "Плагин AIMP",#PB_Window_Tool|#PB_Window_ScreenCentered)
  StickyWindow(0, 1)
  CanvasGadget(0, 10, 28, 180, 64, 0)
  
  GetSpectr()
  BindEvent(#Message, @GetSpectr(), 0)
  
  Repeat
    WaitWindowEvent()
  ForEver
EndProcedure

Procedure SendData(*Data.SpectrData)
  If *Data
    LockMutex(gSpectrInfo\Mutex)
    CopyMemory(@*Data\Arr[0], @gSpectrInfo\Arr[0], SizeOf(SpectrData))
    UnlockMutex(gSpectrInfo\Mutex)
    PostEvent(#Message, 0, 0)
  EndIf
EndProcedure

Procedure Init()
  gSpectrInfo\Mutex = CreateMutex()
  gSpectrInfo\ThreadID = CreateThread(@Thread(), 0)
EndProcedure

EndModule
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 92
; FirstLine = 77
; Folding = --
; EnableUnicode
; EnableXP